// This file is generated by kconfig_compiler_kf5 from iconssettingsbase.kcfg.
// All changes you do to this file will be lost.
#ifndef ICONSSETTINGSBASE_H
#define ICONSSETTINGSBASE_H

#include <qglobal.h>
#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

class IconsSettingsBase : public KConfigSkeleton
{
  Q_OBJECT
  public:

    IconsSettingsBase( QObject *parent = nullptr );
    ~IconsSettingsBase();

    /**
      Set Name of the current icon theme
    */
    void setTheme( const QString & v )
    {
      if (v != mTheme && !isImmutable( QStringLiteral( "Theme" ) )) {
        mTheme = v;
        Q_EMIT ThemeChanged();
      }
    }

    Q_PROPERTY(QString theme READ theme WRITE setTheme NOTIFY ThemeChanged)
    /**
      Get Name of the current icon theme
    */
    QString theme() const
    {
      return mTheme;
    }

    /**
      Get Name of the current icon theme default value
    */
    QString defaultThemeValue() const
    {
        return defaultThemeValue_helper();
    }

    /**
      Set Desktop icons size
    */
    void setDesktopSize( int v )
    {
      if (v != mDesktopSize && !isImmutable( QStringLiteral( "desktopSize" ) )) {
        mDesktopSize = v;
        Q_EMIT desktopSizeChanged();
      }
    }

    Q_PROPERTY(int desktopSize READ desktopSize WRITE setDesktopSize NOTIFY desktopSizeChanged)
    /**
      Get Desktop icons size
    */
    int desktopSize() const
    {
      return mDesktopSize;
    }

    /**
      Get Desktop icons size default value
    */
    int defaultDesktopSizeValue() const
    {
        return defaultDesktopSizeValue_helper();
    }

    /**
      Set Toolbar icons size
    */
    void setToolbarSize( int v )
    {
      if (v != mToolbarSize && !isImmutable( QStringLiteral( "toolbarSize" ) )) {
        mToolbarSize = v;
        Q_EMIT toolbarSizeChanged();
      }
    }

    Q_PROPERTY(int toolbarSize READ toolbarSize WRITE setToolbarSize NOTIFY toolbarSizeChanged)
    /**
      Get Toolbar icons size
    */
    int toolbarSize() const
    {
      return mToolbarSize;
    }

    /**
      Get Toolbar icons size default value
    */
    int defaultToolbarSizeValue() const
    {
        return defaultToolbarSizeValue_helper();
    }

    /**
      Set Main toolbar icons size
    */
    void setMainToolbarSize( int v )
    {
      if (v != mMainToolbarSize && !isImmutable( QStringLiteral( "mainToolbarSize" ) )) {
        mMainToolbarSize = v;
        Q_EMIT mainToolbarSizeChanged();
      }
    }

    Q_PROPERTY(int mainToolbarSize READ mainToolbarSize WRITE setMainToolbarSize NOTIFY mainToolbarSizeChanged)
    /**
      Get Main toolbar icons size
    */
    int mainToolbarSize() const
    {
      return mMainToolbarSize;
    }

    /**
      Get Main toolbar icons size default value
    */
    int defaultMainToolbarSizeValue() const
    {
        return defaultMainToolbarSizeValue_helper();
    }

    /**
      Set Small icons size
    */
    void setSmallSize( int v )
    {
      if (v != mSmallSize && !isImmutable( QStringLiteral( "smallSize" ) )) {
        mSmallSize = v;
        Q_EMIT smallSizeChanged();
      }
    }

    Q_PROPERTY(int smallSize READ smallSize WRITE setSmallSize NOTIFY smallSizeChanged)
    /**
      Get Small icons size
    */
    int smallSize() const
    {
      return mSmallSize;
    }

    /**
      Get Small icons size default value
    */
    int defaultSmallSizeValue() const
    {
        return defaultSmallSizeValue_helper();
    }

    /**
      Set Panel icons size
    */
    void setPanelSize( int v )
    {
      if (v != mPanelSize && !isImmutable( QStringLiteral( "panelSize" ) )) {
        mPanelSize = v;
        Q_EMIT panelSizeChanged();
      }
    }

    Q_PROPERTY(int panelSize READ panelSize WRITE setPanelSize NOTIFY panelSizeChanged)
    /**
      Get Panel icons size
    */
    int panelSize() const
    {
      return mPanelSize;
    }

    /**
      Get Panel icons size default value
    */
    int defaultPanelSizeValue() const
    {
        return defaultPanelSizeValue_helper();
    }

    /**
      Set Dialog icons size
    */
    void setDialogSize( int v )
    {
      if (v != mDialogSize && !isImmutable( QStringLiteral( "dialogSize" ) )) {
        mDialogSize = v;
        Q_EMIT dialogSizeChanged();
      }
    }

    Q_PROPERTY(int dialogSize READ dialogSize WRITE setDialogSize NOTIFY dialogSizeChanged)
    /**
      Get Dialog icons size
    */
    int dialogSize() const
    {
      return mDialogSize;
    }

    /**
      Get Dialog icons size default value
    */
    int defaultDialogSizeValue() const
    {
        return defaultDialogSizeValue_helper();
    }


    enum {
      signalThemeChanged = 0x1,
      signalDesktopSizeChanged = 0x2,
      signalToolbarSizeChanged = 0x4,
      signalMainToolbarSizeChanged = 0x8,
      signalSmallSizeChanged = 0x10,
      signalPanelSizeChanged = 0x20,
      signalDialogSizeChanged = 0x40
    };

  Q_SIGNALS:
    void ThemeChanged();

    void desktopSizeChanged();

    void toolbarSizeChanged();

    void mainToolbarSizeChanged();

    void smallSizeChanged();

    void panelSizeChanged();

    void dialogSizeChanged();

  private:
    void itemChanged(quint64 flags);

  protected:

    // Icons
    QString mTheme;
    QString defaultThemeValue_helper() const;

    // DesktopIcons
    int mDesktopSize;
    int defaultDesktopSizeValue_helper() const;

    // ToolbarIcons
    int mToolbarSize;
    int defaultToolbarSizeValue_helper() const;

    // MainToolbarIcons
    int mMainToolbarSize;
    int defaultMainToolbarSizeValue_helper() const;

    // SmallIcons
    int mSmallSize;
    int defaultSmallSizeValue_helper() const;

    // PanelIcons
    int mPanelSize;
    int defaultPanelSizeValue_helper() const;

    // DialogIcons
    int mDialogSize;
    int defaultDialogSizeValue_helper() const;

  private:
};

#endif

