// This file is generated by kconfig_compiler_kf5 from smserversettings.kcfg.
// All changes you do to this file will be lost.
#ifndef SMSERVERSETTINGS_H
#define SMSERVERSETTINGS_H

#include <qglobal.h>
#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

class SMServerSettings : public KConfigSkeleton
{
  Q_OBJECT
  public:
    enum LoginModeType { restorePreviousLogout, restoreSavedSession, emptySession };

    SMServerSettings( QObject *parent = nullptr );
    ~SMServerSettings();

    /**
      Set Confirm logout
    */
    void setConfirmLogout( bool v )
    {
      if (v != mConfirmLogout && !isImmutable( QStringLiteral( "confirmLogout" ) )) {
        mConfirmLogout = v;
        Q_EMIT confirmLogoutChanged();
      }
    }

    Q_PROPERTY(bool confirmLogout READ confirmLogout WRITE setConfirmLogout NOTIFY confirmLogoutChanged)
    /**
      Get Confirm logout
    */
    bool confirmLogout() const
    {
      return mConfirmLogout;
    }

    /**
      Get Confirm logout default value
    */
    bool defaultConfirmLogoutValue() const
    {
        return defaultConfirmLogoutValue_helper();
    }

    /**
      Set Offer shutdown options
    */
    void setOfferShutdown( bool v )
    {
      if (v != mOfferShutdown && !isImmutable( QStringLiteral( "offerShutdown" ) )) {
        mOfferShutdown = v;
        Q_EMIT offerShutdownChanged();
      }
    }

    Q_PROPERTY(bool offerShutdown READ offerShutdown WRITE setOfferShutdown NOTIFY offerShutdownChanged)
    /**
      Get Offer shutdown options
    */
    bool offerShutdown() const
    {
      return mOfferShutdown;
    }

    /**
      Get Offer shutdown options default value
    */
    bool defaultOfferShutdownValue() const
    {
        return defaultOfferShutdownValue_helper();
    }

    /**
      Set Default leave option
    */
    void setShutdownType( int v )
    {
      if (v != mShutdownType && !isImmutable( QStringLiteral( "shutdownType" ) )) {
        mShutdownType = v;
        Q_EMIT shutdownTypeChanged();
      }
    }

    Q_PROPERTY(int shutdownType READ shutdownType WRITE setShutdownType NOTIFY shutdownTypeChanged)
    /**
      Get Default leave option
    */
    int shutdownType() const
    {
      return mShutdownType;
    }

    /**
      Get Default leave option default value
    */
    int defaultShutdownTypeValue() const
    {
        return defaultShutdownTypeValue_helper();
    }

    /**
      Set On login
    */
    void setLoginMode( int v )
    {
      if (v != mLoginMode && !isImmutable( QStringLiteral( "loginMode" ) )) {
        mLoginMode = v;
        Q_EMIT loginModeChanged();
      }
    }

    Q_PROPERTY(int loginMode READ loginMode WRITE setLoginMode NOTIFY loginModeChanged)
    /**
      Get On login
    */
    int loginMode() const
    {
      return mLoginMode;
    }

    /**
      Get On login default value
    */
    int defaultLoginModeValue() const
    {
        return defaultLoginModeValue_helper();
    }

    /**
      Set Applications to be excluded from session
    */
    void setExcludeApps( const QString & v )
    {
      if (v != mExcludeApps && !isImmutable( QStringLiteral( "excludeApps" ) )) {
        mExcludeApps = v;
        Q_EMIT excludeAppsChanged();
      }
    }

    Q_PROPERTY(QString excludeApps READ excludeApps WRITE setExcludeApps NOTIFY excludeAppsChanged)
    /**
      Get Applications to be excluded from session
    */
    QString excludeApps() const
    {
      return mExcludeApps;
    }


    enum {
      signalConfirmLogoutChanged = 0x1,
      signalOfferShutdownChanged = 0x2,
      signalShutdownTypeChanged = 0x4,
      signalLoginModeChanged = 0x8,
      signalExcludeAppsChanged = 0x10
    };

  Q_SIGNALS:
    void confirmLogoutChanged();

    void offerShutdownChanged();

    void shutdownTypeChanged();

    void loginModeChanged();

    void excludeAppsChanged();

  private:
    void itemChanged(quint64 flags);

  protected:

    // General
    bool mConfirmLogout;
    bool defaultConfirmLogoutValue_helper() const;
    bool mOfferShutdown;
    bool defaultOfferShutdownValue_helper() const;
    int mShutdownType;
    int defaultShutdownTypeValue_helper() const;
    int mLoginMode;
    int defaultLoginModeValue_helper() const;
    QString mExcludeApps;
    QString defaultExcludeAppsValue_helper() const;

  private:
};

#endif

