// This file is generated by kconfig_compiler_kf5 from stylesettings.kcfg.
// All changes you do to this file will be lost.
#ifndef STYLESETTINGS_H
#define STYLESETTINGS_H

#include <qglobal.h>
#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

class StyleSettings : public KConfigSkeleton
{
  Q_OBJECT
  public:

    StyleSettings( QObject *parent = nullptr );
    ~StyleSettings();

    /**
      Set Application style
    */
    void setWidgetStyle( const QString & v )
    {
      if (v != mWidgetStyle && !isImmutable( QStringLiteral( "widgetStyle" ) )) {
        mWidgetStyle = v;
        Q_EMIT widgetStyleChanged();
      }
    }

    Q_PROPERTY(QString widgetStyle READ widgetStyle WRITE setWidgetStyle NOTIFY widgetStyleChanged)
    /**
      Get Application style
    */
    QString widgetStyle() const
    {
      return mWidgetStyle;
    }

    /**
      Get Application style default value
    */
    QString defaultWidgetStyleValue() const
    {
        return defaultWidgetStyleValue_helper();
    }

    /**
      Set Show icons on buttons
    */
    void setIconsOnButtons( bool v )
    {
      if (v != mIconsOnButtons && !isImmutable( QStringLiteral( "iconsOnButtons" ) )) {
        mIconsOnButtons = v;
        Q_EMIT iconsOnButtonsChanged();
      }
    }

    Q_PROPERTY(bool iconsOnButtons READ iconsOnButtons WRITE setIconsOnButtons NOTIFY iconsOnButtonsChanged)
    /**
      Get Show icons on buttons
    */
    bool iconsOnButtons() const
    {
      return mIconsOnButtons;
    }

    /**
      Get Show icons on buttons default value
    */
    bool defaultIconsOnButtonsValue() const
    {
        return defaultIconsOnButtonsValue_helper();
    }

    /**
      Set Show icons in menus
    */
    void setIconsInMenus( bool v )
    {
      if (v != mIconsInMenus && !isImmutable( QStringLiteral( "iconsInMenus" ) )) {
        mIconsInMenus = v;
        Q_EMIT iconsInMenusChanged();
      }
    }

    Q_PROPERTY(bool iconsInMenus READ iconsInMenus WRITE setIconsInMenus NOTIFY iconsInMenusChanged)
    /**
      Get Show icons in menus
    */
    bool iconsInMenus() const
    {
      return mIconsInMenus;
    }

    /**
      Get Show icons in menus default value
    */
    bool defaultIconsInMenusValue() const
    {
        return defaultIconsInMenusValue_helper();
    }

    /**
      Set Main toolbar label
    */
    void setToolButtonStyle( const QString & v )
    {
      if (v != mToolButtonStyle && !isImmutable( QStringLiteral( "toolButtonStyle" ) )) {
        mToolButtonStyle = v;
        Q_EMIT toolButtonStyleChanged();
      }
    }

    Q_PROPERTY(QString toolButtonStyle READ toolButtonStyle WRITE setToolButtonStyle NOTIFY toolButtonStyleChanged)
    /**
      Get Main toolbar label
    */
    QString toolButtonStyle() const
    {
      return mToolButtonStyle;
    }

    /**
      Get Main toolbar label default value
    */
    QString defaultToolButtonStyleValue() const
    {
        return defaultToolButtonStyleValue_helper();
    }

    /**
      Set Secondary toolbar label
    */
    void setToolButtonStyleOtherToolbars( const QString & v )
    {
      if (v != mToolButtonStyleOtherToolbars && !isImmutable( QStringLiteral( "toolButtonStyleOtherToolbars" ) )) {
        mToolButtonStyleOtherToolbars = v;
        Q_EMIT toolButtonStyleOtherToolbarsChanged();
      }
    }

    Q_PROPERTY(QString toolButtonStyleOtherToolbars READ toolButtonStyleOtherToolbars WRITE setToolButtonStyleOtherToolbars NOTIFY toolButtonStyleOtherToolbarsChanged)
    /**
      Get Secondary toolbar label
    */
    QString toolButtonStyleOtherToolbars() const
    {
      return mToolButtonStyleOtherToolbars;
    }

    /**
      Get Secondary toolbar label default value
    */
    QString defaultToolButtonStyleOtherToolbarsValue() const
    {
        return defaultToolButtonStyleOtherToolbarsValue_helper();
    }


    enum {
      signalWidgetStyleChanged = 0x1,
      signalIconsOnButtonsChanged = 0x2,
      signalIconsInMenusChanged = 0x4,
      signalToolButtonStyleChanged = 0x8,
      signalToolButtonStyleOtherToolbarsChanged = 0x10
    };

  Q_SIGNALS:
    void widgetStyleChanged();

    void iconsOnButtonsChanged();

    void iconsInMenusChanged();

    void toolButtonStyleChanged();

    void toolButtonStyleOtherToolbarsChanged();

  private:
    void itemChanged(quint64 flags);

  protected:

    // KDE
    QString mWidgetStyle;
    QString defaultWidgetStyleValue_helper() const;
    bool mIconsOnButtons;
    bool defaultIconsOnButtonsValue_helper() const;
    bool mIconsInMenus;
    bool defaultIconsInMenusValue_helper() const;

    // Toolbar style
    QString mToolButtonStyle;
    QString defaultToolButtonStyleValue_helper() const;
    QString mToolButtonStyleOtherToolbars;
    QString defaultToolButtonStyleOtherToolbarsValue_helper() const;

  private:
};

#endif

